<template>
  <div id="sdkContainer"></div>
</template>

<script>
import { GisServe, SgsServe } from "../utils/config";
import axios from "axios";
import Builder from "../../public/Json/builder.json";
import poi1 from "../../public/Json/POI1.json";
import SD from "../../public/Json/SD.json";
import SGSM from "../../public/Json/SGSM.json";
import XD from "../../public/Json/SD.json";
import YJDL from "../../public/Json/YJDL.json";
export default {
  name: "mapindex",
  data () {
    return {
      earthimg: require("../assets/img/Map/earth.jpg"),
    };
  },
  methods: {
    init3DMap () {
      window.sgworld = new SmartEarth.SGWorld(
        "sdkContainer",
        Cesium,
        this.earthimg,
        null,
        function () { }
      );
      window.Viewer = sgworld._Viewer;
      sgworld.Navigate.Stop(); //取消飞行状态
      sgworld.Navigate.jumpTo({
        //跳转视角
        destination: new Cesium.Cartesian3.fromDegrees(
          118.69782585090609,
          36.90055563144302,
          1489.160420056435
        ),

        orientation: {
          heading: 2.4388641438831566,
          pitch: -0.32357670142998063,
          roll: 0.0,
        },
      });
      //显示fps
      sgworld._Viewer.scene.debugShowFramesPerSecond = false;
      window.Viewer = sgworld._Viewer;
      Viewer.imageryLayers.removeAll();
      Viewer.scene.globe.baseColor = Cesium.Color.fromCssColorString("#091A2A");
      //跳转视角
      sgworld.Navigate.jumpTo({
        destination: new Cesium.Cartesian3.fromDegrees(
          118.69782585090609,
          36.90055563144302,
          1489.160420056435
        ),

        orientation: {
          heading: 2.4388641438831566,
          pitch: -0.32357670142998063,
          roll: 0.0,
        },
      });
      //加载mpt影响数据
      // this.getMPTDate();
      //加载3d模型
      // this.getC3DModel();
      // 加载面数据
      this.getGisServerPolygon();
      // 加载线数据
      this.getGisServerPline();
      // 加载点数据
      // this.getGisServerPoint();
    },
    getMPTDate () {
      var urls = SgsServe + "/streamer.ashx/Imagery";
      var dx = sgworld.Creator.createImageryProvider(
        "mpt影像",
        "wms",
        {
          url: urls,
          layers: "SG_ZXYX.572872.I.mpt",
        },
        "0",
        undefined,
        true,
        ""
      );
    },
    getC3DModel () {
      // var url1 = "http://127.0.0.1:81/SGS/_%E5%94%90%E5%AE%817%E5%8F%B7%E5%92%8C%E5%9B%AD.591367/tileset.json";
      // var tiltModel1 = sgworld.Creator.create3DTilesets(
      //   "",
      //   url1,
      //   {},
      //   {},
      //   "0",
      //   true,
      //   function (data) {
      //     sgworld.Navigate.jumpTo(data)
      //   }
      // );
      // var url1 = "/b3dm/A-2.591356/tileset.json";
      // var tiltModel1 = sgworld.Creator.create3DTilesets(
      //   "",
      //   url1,
      //   {},
      //   {},
      //   "0",
      //   true,
      //   function (data) {}
      // );
      // var url1 = SgsServe + "/SE/b3dm/B-1.591357/tileset.json";
      // var tiltModel1 = sgworld.Creator.create3DTilesets(
      //   "",
      //   url1,
      //   {},
      //   {},
      //   "0",
      //   true,
      //   function (data) {}
      // );
      // var url1 = SgsServe + "/SE/b3dm/B-2.591358/tileset.json";
      // var tiltModel1 = sgworld.Creator.create3DTilesets(
      //   "",
      //   url1,
      //   {},
      //   {},
      //   "0",
      //   true,
      //   function (data) {}
      // );
      // var url1 = SgsServe + "/SE/b3dm/C-1.591359/tileset.json";
      // var tiltModel1 = sgworld.Creator.create3DTilesets(
      //   "",
      //   url1,
      //   {},
      //   {},
      //   "0",
      //   true,
      //   function (data) {}
      // );
      // var url1 = SgsServe + "/SE/b3dm/C-2.591360/tileset.json";
      // var tiltModel1 = sgworld.Creator.create3DTilesets(
      //   "",
      //   url1,
      //   {},
      //   {},
      //   "0",
      //   true,
      //   function (data) {}
      // );
    },
    getGisServerPolygon () {
      var polygonfile = {
        far: 20000000,
        heightReference: 1,
        layertype: "polygonlayer",
        near: 0,
        outline: true,
        outlineColor: "#fff",
        outlineWidth: 1,
        extrudedHeight: undefined,
        material: "#00f",
      };
      var sgpolygon = sgworld.Creator.createPolygonGeoJsonFeatureLayer(
        "SHOUGUANGCITY",
        SGSM,
        polygonfile,
        "0",
        true,
        function (layer_data) {
          for (
            var a = 0;
            a < layer_data.entities._entities._array.length;
            a++
          ) {
            var ent = layer_data.entities._entities._array[a];
            ent.polygon.material.color = new Cesium.Color(
              2550 / 255,
              6630 / 255,
              10710 / 255,
              0.7
            );
          }
        }
      );

      var url1 = "http://192.168.20.55:8080/sg/tileset.json";
      var tiltModel1 = sgworld.Creator.create3DTilesets(
        "",
        url1,
        {},
        {
          colors: "rgba(0,210,255,0.7)",
          outlineColor: "#6DB5EA",
        },
        "0",
        true,
        function (data) { }
      );
    },
    // getGisServerPline () {
    //   var pathLayer = sgworld.Creator.createPathLayer({
    //     url: YJDL,
    //     color: "#0033FF", //线的颜色
    //     width: 10.0, //线的宽度
    //     pointColor: "#FFFFFF", //移动点的颜色
    //     speed: 5,
    //   });

    //   var pathLayer = sgworld.Creator.createPathLayer({
    //     url: XD,
    //     color: "#0033FF", //线的颜色
    //     width: 10.0, //线的宽度
    //     pointColor: "#FFFFFF", //移动点的颜色
    //     speed: 5,
    //   });

    //   var data = {
    //     arcType: 0,
    //     material: "#00f",
    //     clampToGround: true,
    //     far: 50000000,
    //     layertype: "Streetscape",
    //     near: 0,
    //     opacity: "1",
    //     width: 3,
    //   };
    //   var dx = sgworld.Creator.createStreetscapeGeoJsonFeatureLayer(
    //     "",
    //     SD,
    //     data,
    //     "0",
    //     true,
    //     function (data) { }
    //   );
    // },
    getGisServerPline () {
      var pathLayer = sgworld.Creator.createPathLayer({
        url: YJDL,
        color: "#0033FF", //线的颜色
        width: 10.0, //线的宽度
        pointColor: "#FFFFFF", //移动点的颜色
        speed: 5,
        far: 50000,
      });

      var pathLayer = sgworld.Creator.createPathLayer({
        url: XD,
        color: "#0033FF", //线的颜色
        width: 10.0, //线的宽度
        pointColor: "#FFFFFF", //移动点的颜色
        speed: 5,
      });
      var data = {
        arcType: 0,
        material: "#00f",
        clampToGround: true,
        far: 50000000,
        layertype: "Streetscape",
        near: 0,
        opacity: "1",
        width: 3,
      };
      var dx = sgworld.Creator.createStreetscapeGeoJsonFeatureLayer(
        "",
        SD,
        "0",
        true,
        function (data) { }
      );
    },
    getGisServerPoint () {
      var data = {
        far: 90000000,
        color: "#020F1F",
        outlineColor: "#020F1F",
        layertype: "pointlayer",
        near: 0,
        outlineWidth: 2,
        pixelSize: 10,
        pointHeight: 10,
      };
      var dx = sgworld.Creator.createPointGeojsonFeatureLayer(
        "",
        poi1,
        data,
        "0",
        true,
        function (data) {
          sgworld.Navigate.flyToObj(data);
        }
      );
    },
  },
  mounted () {
    this.init3DMap();
  },
};
</script>

<style scoped>
#sdkContainer {
  width: 100%;
  height: 100%;
  margin: 0;
  padding: 0;
  overflow: hidden;
}
</style>
